#include "X3D_X3DTexture2DNode.h"

namespace X3DTK {
namespace X3D {

X3DTexture2DNode::X3DTexture2DNode()
: X3DTextureNode(), _repeatS(true), _repeatT(true)
{
  defineTypeName("X3DTexture2DNode", "Texturing");
}

X3DTexture2DNode::X3DTexture2DNode(const X3DTexture2DNode &N)
: X3DTextureNode(N), _repeatS(N._repeatS), _repeatT(N._repeatT)
{
}

X3DTexture2DNode::~X3DTexture2DNode()
{
}

void X3DTexture2DNode::setRepeatS(const SFBool &repeatS)
{
  _repeatS = repeatS;
}

void X3DTexture2DNode::setRepeatT(const SFBool &repeatT)
{
  _repeatT = repeatT;
}

void X3DTexture2DNode::load(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("repeatS");
  if (index != -1)
    _repeatS = (element->getAttribute(index).upper() == "TRUE");  
  
  index = element->getIndexAttribute("repeatT");
  if (index != -1)
    _repeatT = (element->getAttribute(index).upper() == "TRUE");    
}

SFString &X3DTexture2DNode::write(SFString &output) const
{
  if (!_repeatS)
    output += " repeatS=\"FALSE\"";
  if (!_repeatT)
    output += " repeatT=\"FALSE\"";
    
  return output;
}

}
}
