#include "GraphTester.h"
#include "X3DAbstractNode.h"
#include "DFSGraphTraversal.h"
#include "GraphTesterAbstractVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {

GraphTester::GraphTester()
{
  stateVariables = Singleton<GraphTesterStateVariables>::getInstance();
  
  graphTraversal = new DFSGraphTraversal();
  
  graphTraversal->setComponentVisitor(new GraphTesterAbstractVisitor());
}

GraphTester::~GraphTester()
{
  Singleton<GraphTesterStateVariables>::removeInstance();
  
  delete graphTraversal;
}
  
void GraphTester::test(SFAbstractNode N) const
{
  stateVariables->init();
  graphTraversal->traverse(N);
}
  
}
